+++
date = 2013-08-03T00:00:00+00:00
title = "ARM host"
tags = ["embedded"]
+++


I'd like a lower power server for inside my home. Some requirements:

  - Cortex-A9, quad core, 1.2 Ghz or more.
  - 2 GiB
  - Ethernet. USB hosted is OK, native gigabit is better.
  - 2 or more USB ports.
  - A public git tree.

And would be nices:

  - In the Linus kernel
  - Real datasheets (yay Freescale\!)
  - Fit within a 3.5" drive envelope (102 x 25 mm, 18 mm for 'airflow')

Mass storage will come from the NAS. If it's small enough then it can
fit in a spare drive bay.

Some potentials:

  - Wandboard Quad. 95 x 95 mm, unknown height.
  - ODROID-X2, 90 x 95 mm, unknown height.

Update: 2013-08-01: I decided on the Freescale i.MX6 based Wandboard.
Quite happy so far. SATA is broken but possible. Tops out at 70 deg C at
1 GHz.

# Synology 213 as a Freedombox

I'd like to self host and move my current VPS into my home. I have an
ARM-based Synology NAS which can also run Debian in a chroot. Here's the
setup.

Installing Debian:

  - Start at <http://www.synocommunity.com/>
  - Add the <http://packages.synocommunity.com/> source
  - Open the `Package Center`
  - Click on `Community`
  - Install `Python`
  - Install `Debian Chroot`

It looks like the package does a `debootstrap` as part of the install.

  - Once installed, select `Action | Run`

Enter the chroot and do basic setup:

  - `/var/packages/debian-chroot/scripts/start-stop-status chroot`
  - `vi /etc/apt/sources.list`
  - Keep wheezy enabled, drop the others
  - `apt-get update`
  - `apt-get dist-upgrade`
  - `apt-get install -yq jed locales sudo`
  - `dpkg-reconfigure locales tzdata`

Add the SSH server on a custom port:

  - apt-get install -yq jed openssh-server
  - jed /etc/ssh/sshd\_config
  - Update `Port`
  - cd /etc
  - mkdir rc.syno.d
  - cd rc.syno.d
  - ln -s ../init.d/ssh

Update the DSM-side start script to also start services:

  - vi /var/packages/debian-chroot/scripts/start-stop-status
  - Add the following after the last grep/mount in start\_daemon:

`chroot ${CHROOTTARGET}/ /bin/run-parts -a start /etc/rc.syno.d`

Add the user account:

  - Add in the DSM side under `Control Panel | User`
  - Grab the user ID from `/etc/passwd`
  - Add in the chroot with the same user ID: `adduser --uid xxxx
    username`

You now have a Debian chroot with SSH access. Have at it\!

Notes:

  - The chroot is stored at
    `/volume1/@appstore/debian-chroot/var/chroottarget`. Don't forget to
    back it up.
  - Add any services manually to `/etc/rc.syno.d`

