+++
date = 2015-07-08T00:00:00+00:00
title = "Bone v2"
tags = ["embedded"]
+++

I'm using a small, no-name RT5370 from
[ebay](http://www.ebay.co.uk/itm/For-Raspberry-PI-RT5370-Mini-150Mbps-802-11n-Wireless-USB-Adapter-WiFi-Dongle-/281708681865).
It's not fast but it is compatible and reliable, unlike the other three
adapters that I have.

Disable interface renaming:

    cd /etc/udev/rules.d; ln -sf /dev/null 70-persistent-net.rules

Note that you can't just delete the file as systemd recreates it.

Setup /etc/network/interfaces:

    allow-hotplug wlan0
    iface wlan0 inet dhcp
        pre-up sleep 2
        pre-up rfkill unblock all
        wpa-ssid "your-ssid-here"
        wpa-psk  "your-password-here"

Note that during the boot, systemd seems to randomly set the rfkill bit
which causes dhcpclient to show '300 byte' errors. The `sleep; unblock`
hack works around this. sleep to work around race conditions FTW\!

Update the kernel:

    cd /opt/scripts/tools
    git pull
    apt-cache search linux-image bone
    ./update_kernel.sh --kernel 4.1.1-bone9

## Enabling ports

See https://eewiki.net/display/linuxonarm/BeagleBone+Black for building
the device tree overlays.

``` 
 echo BB-UART1 > /sys/devices/platform/bone_capemgr/slots
```

The pinouts are at
http://elinux.org/Beagleboard:Cape\_Expansion\_Headers\#4.5\_Serial\_UARTs

## Adafruit 1.8" display

There seems to be probles with SPI on the 4.1 kernel and the 3.14 kernel
is missing the cape manager. 3.8 works fine though.

https://github.com/notro/fbtft/wiki/LCD-Modules\#adafruit-18

    GND      1
    VCC      2
    RST      3 -> 15 (GPIO48)
    DC       4 -> 23 (GPIO49)
    CARD_CS  5
    LCD_CS   6 -> 17
    MOSI     7 -> 18
    SCK      8 -> 22
    MISO     9
    LITE     10 -> VCC
    
    
    echo BB-SPIDEV0 > /sys/devices/bone_capemgr*/slots
    modprobe -f fb_st7735r
    modprobe -f fbtft_device name=adafruit18 busnum=1 gpios=reset:48,dc:49
    con2fbmap 1 1

