+++
date = 2013-06-26T00:00:00+00:00
title = "Olimex STM32-H103 Notes"
tags = ["embedded"]
+++


The [Olimex](https://www.olimex.com/)
[STM32-H103](https://www.olimex.com/Products/ARM/ST/STM32-H103/) is a
[ST](http://st.com) STM32F1 based development. Pluses are the USB port,
proper JTAG connector, and all I/O out on 0.1" pitch pins.

Details:

  - STM32F103RBT6 CPU
  - 128 Ki flash, 20 Ki RAM, 72 Mhz
  - Standard 20 pin JTAG connector
  - Green STAT LED on PC12
  - 8 MHz crystal

Links:

  - Manual
    <https://www.olimex.com/Products/ARM/ST/STM32-H103/resources/STM32-H103.pdf>
  - Schematic
    <https://www.olimex.com/Products/ARM/ST/STM32-H103/resources/STM32-H103-sch.gif>

## Programming

I used the Ubuntu Raring OpenOCD 0.6.0 and a Signalyzer Lite. The host
is a Macbook Air running Windows with Ubuntu Raring in a VM. OpenOCD
sometimes fails with a `Error: unable to open ftdi device: unable to
fetch product description` error, but re-plugging the JTAG device fixes
that.

A basic OpenOCD config file works fine:

    # Olimex STM32-H103
    source [find interface/signalyzer-lite.cfg]
    source [find target/stm32f1x.cfg]

Programming via `telnet localhost 4444` involves:

    reset halt
    flash probe 0
    stm32f1x mass_erase 0
    flash write_image blink.hex 0 ihex
    reset run

