---
title: Heading controller progress
author: michaelh
type: post
date: 2014-02-02T16:55:18+00:00
url: /2014/02/heading-controller-progress/
categories:
  - nppilot

---
The heading controller is basically working. The big changes were reducing the maximum steering angle to reducing how much trouble the controller can get itself into, and putting the gain on the dial so I could tune it while driving. There&#8217;s still a lot of slow oscillation so I I&#8217;ll add a differential term to counter how steering angle integrates to heading.

The reliability problem has gone after switching from the golang [gc][1] compiler to [gccgo][2]. I think there&#8217;s a problem with the runtime as the whole app locks up and gdb reports all threads being in a function with &#8216;futex&#8217; in the name. I want to report this to the golang team, but how do you reduce &#8220;a 10 thread 1000 line program, on ARM, on a random kernel, in the cold, in a noisy environment, sometimes locks up after 10 minutes of activity.&#8221;

Next step is the differential term. I only have GPS heading so I&#8217;ll look at the run data and see how noisy the heading differential is. Getting a [gyro][3] is tempting.

Actually, the zeroth step is replacing the [front wishbone][4]:

[<img src="https://juju.net.nz/michaelh/blog/wp-content/uploads/2014/02/IMG_20140202_165208-300x225.jpg" alt="IMG_20140202_165208" width="300" height="225" class="alignnone size-medium wp-image-138" srcset="https://juju.net.nz/michaelh/blog/wp-content/uploads/2014/02/IMG_20140202_165208-300x225.jpg 300w, https://juju.net.nz/michaelh/blog/wp-content/uploads/2014/02/IMG_20140202_165208-1024x768.jpg 1024w, https://juju.net.nz/michaelh/blog/wp-content/uploads/2014/02/IMG_20140202_165208-400x300.jpg 400w" sizes="(max-width: 300px) 100vw, 300px" />][5]

I must have half broken it in the first Great Crash, and last nights glue job didn&#8217;t hold. Conrad want an excessive 50 CHF including shipping for two of them and a new bumper. German word of the day: a bumper is the much more awesome [Frontrammer][6].

 [1]: http://golang.org/cmd/gc/
 [2]: http://gcc.gnu.org/onlinedocs/gccgo/
 [3]: http://www.adafruit.com/products/1032
 [4]: http://www.conrad.ch/ce/de/product/232789/Reely-EL347FEL347R-Ersatzteil-Untere-Querlenker-vorne-hinten
 [5]: https://juju.net.nz/michaelh/blog/wp-content/uploads/2014/02/IMG_20140202_165208.jpg
 [6]: http://www.conrad.ch/ce/de/product/223353/Reely-MV1401-Ersatzteil-Frontrammer