---
title: Arietta 25
author: michaelh
type: post
date: 2014-06-29T19:51:29+00:00
url: /2014/06/arietta-25/
categories:
  - Uncategorized

---
I picked up two [Acme Systems][1] [Arietta G25][2]&#8216;s. They&#8217;re a tiny Atmel ARM9 powered board with most of the I/O out on a 0.1&#8243; header. I hope to hook one up to a GPS to send up in my plane and record the track and speed.

Some random notes:

The board shows up as a [USB CDC EEM][3] Ethernet adapter. ChromeOS includes the CDC Ether but not the EEM driver. I built the [chromeos-3.8.11][4] EEM driver from source and it worked just fine.

The usual SSH port forwarding trick works well for installing extra packages. Run [Polipo][5] somewhere on your network, SSH into the board with port forwarding (`-R 8123:proxy-name:8123`), set the proxy (`export http_proxy=http://localhost:8123/`), and apt-get away.

The default hostname is arietta. Add it to the localhost line in `/etc/hosts` to make sudo faster.

The default golang packages that come with x86_64 Ubuntu Trusty work great for cross compiling, and the statically linked binaries run on the board with no extra support. Try `GOARCH=arm GOARM=5 go build`.

I can&#8217;t figure out how to build a Device Tree script into the binary form. The Linux kernel uses `#include` and abuses the C preprocessor, but you need a whole set of flags to cut the extra noise that cpp adds so that dtc can still parse the output. Copying into the Kernel tree works fine.

 [1]: http://www.acmesystems.it/
 [2]: http://www.acmesystems.it/arietta
 [3]: https://en.wikipedia.org/wiki/Ethernet_over_USB
 [4]: https://chromium.googlesource.com/chromiumos/third_party/kernel/
 [5]: http://www.pps.univ-paris-diderot.fr/~jch/software/polipo/