---
title: golang and realtime musings
author: michaelh
type: post
date: 2014-10-19T18:23:21+00:00
url: /2014/10/golang-and-realtime-musings/
categories:
  - nppilot

---
I&#8217;m using [golang][1] as the language for my self balancing robot project. It should be interesting as golang is designed for server loads, not for realtime, but the bot will need to update at 100 Hz (10 ms/cycle) to say upright.

I had a look at [the source][2] and there&#8217;s a few issues:

No priorities. The fast control loop should take priority but goroutines are cooperative, have no concept of priority, and are multiplexed onto threads in undefined ways.

The timers are fired from one thread. Ideally timers should have priority and smear, so the control timer can fire first and any other timers can run at roughly the right time when the CPU has gone idle.

The garbage collector is stop world. It&#8217;d be nice if the control thread had its own GC pool. Not going overboard with short lived objects should keep this under control.

The next step is to measure see if any of this is a problem. I plan to have the control loop set a pin on entry and clear it on exit, and then use a [ATTINY][3] as a timer to measure the start and runtime jitter.

 [1]: http://golang.org/
 [2]: http://golang.org/doc/install/source
 [3]: http://www.atmel.com/devices/attiny85.aspx