---
title: Adding buttons on the Linkit Smart
author: michaelh
type: post
date: 2016-01-10T20:25:58+00:00
url: /2016/01/adding-buttons-on-the-linkit-smart/
categories:
  - hacking

---
Here&#8217;s what I found out while trying to add buttons to the OpenWrt based [Linkit Smart][1].

The flow is:

  * Keys are defined in [`target/linux/ramips/dts/LINKIT7688.dts`][2] 
      * [`gpio-button-hotplug`][3] emulates `gpio-keys-polled` and generates uevents. 
          * The uevent is received onver netlink by procd in [`plug/hotplug.c`][4] 
              * The event is dispatched via [`/etc/hotplug.json`][5] 
                  * The standard dispatch rule calls `/etc/rc.buttons/$BUTTON` </ul> 
                    The DTS fragment is:
                    
                    <pre>gpio-keys-polled {
                ...
                btn2 {
                        label = "btn2";
                        gpios = &lt;&#038;gpio0 2 1>;
                        linux,code = &lt;0x102>;
                };
</pre>
                    
                    where the `<&#038;gpio0 2 1>` picks the second pin from the zeroth port i.e. GPIO 2 and
  
                    maps it to BTN_2. See [`uapi/linux/input.h`][6] for the other key codes.
                    
                    gpio-button-hotplug supports a limited number of keys. See the source for the
  
                    current list, which is `BTN_0` to `BTN_9`, `power`, `reset`, `rfkill`, `wps`, and `wwan`.
                    
                    Also, the LinkIt uses a binary wifi driver which seems to be _very_ sensitive to
  
                    the kernel version. I ended up reverting [`363508bcabd8e9205f5fffc8ff282439e61d618f`][7]
  
                    to bring OpenWrt back to 3.18.21 to stop it crashing when the interface comes up.

 [1]: http://www.seeedstudio.com/depot/LinkIt-Smart-7688-p-2573.html
 [2]: https://github.com/openwrt/openwrt/blob/chaos_calmer/target/linux/ramips/dts/LINKIT7688.dts
 [3]: https://github.com/openwrt/openwrt/blob/master/package/kernel/gpio-button-hotplug/src/gpio-button-hotplug.c
 [4]: http://git.openwrt.org/?p=project/procd.git;a=blob;f=plug/hotplug.c
 [5]: https://github.com/openwrt/openwrt/blob/master/package/system/procd/files/hotplug.json
 [6]: http://lxr.free-electrons.com/source/include/uapi/linux/input.h
 [7]: https://github.com/openwrt/openwrt/commit/363508bcabd8e9205f5fffc8ff282439e61d618f