+++
date = "2020-08-29T00:02:42+02:00"
title = "Bixler 3 Drone"
highlight = true
draft = false
+++

I recently purchased a HobbyKing [Bixler 3][bixler3] to use as a autopilot
platform and am pretty happy with how it turned out.  Both the under
wing area and nose area have plenty of room and could easily fit a
[Pixhawk 4 Mini][p4m] with GPS and telemetry.

I prefer the Pixhawk 4 Mini over the older [Pixfalcon][pixfalcon] for
a few reasons:

- the servo connectors are built-in to the module
- the safety switch is built-in to the GPS
- two of the four sides are connector free, making it easier to route

I ended up putting the power distribution board in the under wing area
and 3D printing a hatch to hold everything else:

![Hatch](./ap.png)

The hatch is held on by the front tongue and 2x magnets.  The
autopilot, telemetry, and RX are on the bottom of the hatch and the
GPS on top:

![Cropped to autopliot](./20200824_171653.jpg)

The plane flew just fine in stabilised and hold mode with the default
PX4 aircraft turnings.  I was a bit surprised by how PX4 handles a
strong headwind - if the plane can't make progress in hold mode at the
cruise throttle then it gives up and switches back to stabilised
mode.

![Overall](./20200824_171641.jpg)

Once the weather clears up I hope to do some waypoint tests.  I'd also
like to find a quieter propeller.  The stock is fine, but it's
slightly unbalanced and could be much quieter.

[bixler3]: https://hobbyking.com/en_us/h-king-bixler-3-glider-1550-pnf.html
[p4m]: https://shop.holybro.com/pixhawk4-mini_p1120.html
[pixfalcon]: https://docs.px4.io/v1.9.0/en/flight_controller/pixfalcon.html
