---
title: "AT-09 BLE to UART notes"
authors: ['michaelh']
date: 2021-03-14T16:34:46+01:00
lastmod: 2021-03-14T16:34:46+01:00

image:
  caption: ""
  focal_point: ""
  preview_only: false

projects: ['solarch']
---
I picked up a couple of AT-09 Bluetooth to UART bridges for my solar at home project. Both the BMS and inverter have different grounds than the rest of the system, so rather than worry about isolating the signals I plan to send them over Bluetooth instead.

The modules have a few gotchas:

- It seems to have an intra-character timeout of < 0.1 s. If you type in commands manually then the characters don't arrive fast enough and the module returns `ERROR`, so it's best to write a script instead.
- Any mutate command causes a reset which takes ~1 s, so it's best to wait for the module to come back by sending `AT` until you get `OK`.
- [This is the best manual I could find](http://denethor.wlu.ca/arduino/MLT-BT05-AT-commands-TRANSLATED.pdf) and [this is the best blog post](https://blog.yavilevich.com/2017/03/mlt-bt05-ble-module-a-clone-of-a-clone/).

`AT+HELP` gives a list of commands but it's incomplete. For reference, I used the following to configure the module:

* `AT+BAUD5` - set the baud rate to 19200. 4 is 9600.
* `AT+NAMEPhoenix 24/375` - set the display name.
* `AT+TYPE1` - require a pin to connect.
* `AT+PIN123123` - set the 6 digit pin.

Note that each line must end with a `\r\n`.
