import numpy as np
import matplotlib.pyplot as plt

Vpp = 34.3
Vmin = 30.1
P = np.arange(1, 315 + 1)


def delivered(r: float, p: float) -> float:
    i = p / Vpp
    vdrop = i * r
    vc = Vpp - vdrop
    if vc <= Vmin:
        return 0
    return vc * i


plt.plot(P, [delivered(0.71, p) for p in P], label='1 mm2')
plt.plot(P, [delivered(0.28, p) for p in P], color='r', label='2.5 mm2')
plt.plot(P, P, color='g', label='limit')

plt.xlim(0, max(P))
plt.ylim(0, max(P))
plt.legend()
plt.title('Delivered power')
plt.xlabel('Ppv')
plt.ylabel('Pdelivered')
plt.grid()

plt.savefig('sim.png', transparent=True, bbox_inches='tight')
#plt.show()
