---
# Documentation: https://sourcethemes.com/academic/docs/managing-content/

title: "nppilot using Ardupilot"
authors: ["michaelh"]
date: 2022-01-16T17:44:44+01:00
lastmod: 2022-01-16T17:44:44+01:00
projects: ["nppilot"]
---

I've been working on nppilot, the "never complete autopilot" project for some time now. The latest iteration uses a [Traxxas Revo 1/16][revo], an [OpenPilot Revolution][oprevo] for I/O, and a Raspberry Pi 3B running [ROS][ros] as the command computer.

And it works! Here's the car running a figure-8 pattern:

{{<video src="figure8.mp4" controls="yes" >}}

It doesn't do much at the moment, but that's more progress than the other reboots.

Some notes on the setup:

- I changed the spur gear down to 18T to reduce the top speed, get more speed control, and reduce the number of high speed crashes...
- Wifi with a range extender seems fine as a monitoring link
- I tried a Pi 4B, but my USB power bank can't supply enough current. This matches [benchmarks][pwr] where the 4B is 2.7 W at idle vs 1.2 W.

[revo]: https://traxxas.com/products/models/electric/erevo-vxl-116-tsm
[oprevo]: https://ardupilot.org/copter/docs/common-openpilot-revo-mini.html
[ros]: https://ros.org/
[pwr]: https://www.pidramble.com/wiki/benchmarks/power-consumption
